#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  int i;
  FILE *fp;
  char *c,sin[256],sout[256];

  switch (argc)
  {
    case 2:
      if ((fp=fopen(argv[1],"r")) == NULL)
      {
        perror("fopen");
        exit(1);
      }
      break;
   default:
     printf("usage: tabfix <filename>\n");
     exit(1);
  }
  while (fgets(sin,255,fp) != NULL)
  {
    for (i=0,c=sin; c != NULL && i<256; c++)
    {
      if (*c == '\t') 
      {
        if (i > 0 && sout[i-1] == ' ') continue;
        //if (i > 1 && sout[i-1] == ' ' && sout[i-2] == ' ') continue;
        sout[i++] = ' ';
        //sout[i++] = ' ';
      }
      else 
      {
        if (*c == ' ')
        { 
          if (i > 0 && sout[i-1] == ' ') continue;
        }
        sout[i++] = *c;
      }
      if (*c == 0) break;
    }
    printf("%s",sout);
  }
  fclose(fp);
  return 0;
}
